package abhi.com.example.abhijeetj.filedownload;

import android.os.Bundle;
import android.os.Environment;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.NetworkResponse;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.HttpHeaderParser;
import com.android.volley.toolbox.HurlStack;
import com.android.volley.toolbox.Volley;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

/**
 * Created by abhijeet.j on 02-06-2016.
 */
public class StreamToPdf extends AppCompatActivity implements View.OnClickListener {
    String strApiKey;
    TextView tvConversionContent;
    String strValue;
    String webUrl = null;
    File gpxfile = null;
    int i = 0;
    String fileName;
    File root;
    Button btnConvertStreamToPdf;
    Button btnWebPageToImage;
    Button btnHtmlStringToPdf;
    private RequestQueue mRequestQueue;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.stream_to_pdf_convert);
        //Initialize the Widgets
        init();
        getSupportActionBar().setTitle("Stream To PDF Converter");
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
    }

    public void execute() {
        //Here checking net is available or not
        if (NetworkAvailablity.hasInternetConnection(this)) {

            getPdf();
        } else {
            Toast.makeText(getBaseContext(), "Network is not available", Toast.LENGTH_SHORT).show();
        }


    }

    private void init() {
        tvConversionContent = (TextView) findViewById(R.id.tvConversionContent);
        btnConvertStreamToPdf = (Button) findViewById(R.id.btnConvertStreamToPdf);
        btnWebPageToImage = (Button) findViewById(R.id.webpagetoanimage);
        btnHtmlStringToPdf=(Button)findViewById(R.id.htmlStringToPdf);
        btnConvertStreamToPdf.setOnClickListener(this);
        btnWebPageToImage.setOnClickListener(this);
        btnHtmlStringToPdf.setOnClickListener(this);


    }

    //Here Web Api is called to get Stream and convert it to PDF
    public void getPdf() {
        strApiKey = "af6f46c4-471c-4ce8-8b70-3c78e8ec796b";//Web api Parameter
        strValue = "http://www.google.com"; //Web api Parameter
        webUrl = "http://api.html2pdfrocket.com/pdf";//Web Api Url
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("apiKey", strApiKey);
        params.put("value", strValue);

        webUrl = "http://api.html2pdfrocket.com/pdf";
        String mUrl = webUrl;
        InputStreamReader request = new InputStreamReader(Request.Method.POST, webUrl,
                new Response.Listener<byte[]>() {
                    @Override
                    public void onResponse(byte[] response) {
                        // TODO handle the response
                        try {
                            if (response != null) {
                                Random r = new Random();
                                int i1 = r.nextInt(80 - 65) + 65;
                                fileName = "sample" + i1 + ".pdf";
                                root = new File(Environment.getExternalStorageDirectory(), "WebPageToPdf");
                                if (!root.exists()) {
                                    root.mkdirs();
                                }
                                if (root.exists()) {

                                    if (gpxfile == null || !gpxfile.exists()) {
                                        gpxfile = new File(root, "sample" + i1 + ".pdf");
                                        OutputStream op = new FileOutputStream(gpxfile);
                                        gpxfile.setWritable(true);
                                        op.write(response);
                                        op.flush();
                                        op.close();
                                    } else {

                                        if (gpxfile.exists()) {
                                            OutputStream op = new FileOutputStream(gpxfile, true);
                                            op.write(response);
                                            op.flush();
                                            op.close();
                                        }
                                    }


                                }
                                tvConversionContent.setText(response.toString());
                                Toast.makeText(getBaseContext(), "Content Write To the file name sample" + i1 + " .pdfin WebPageToPdf Directory", Toast.LENGTH_LONG).show();
                                System.out.print("Response ----------------------" + response.toString());

                            }
                        } catch (Exception e) {
                            Log.d("KEY_ERROR", "UNABLE TO DOWNLOAD FILE");
                            e.printStackTrace();
                        }
                    }
                }
                , new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                error.printStackTrace();
            }
        }, params);
        RequestQueue mRequestQueue = Volley.newRequestQueue(getApplicationContext(), new HurlStack());
        mRequestQueue.add(request);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btnConvertStreamToPdf:
                execute();
                break;
            case R.id.webpagetoanimage:
                toConvertWebPagesToAnImage();
                break;
            case R.id.htmlStringToPdf:
                toConvertHtmlStringToPdf();
                break;
        }
    }

    public void toConvertWebPagesToAnImage() {
        strApiKey = "af6f46c4-471c-4ce8-8b70-3c78e8ec796b";//Web api Parameter
        strValue = "http://www.google.com"; //Web api Parameter
        webUrl = "http://api.html2pdfrocket.com/pdf";//Web Api Url
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("apiKey", strApiKey);
        params.put("value", strValue);
        params.put("OutputFormat", "jpg");
        webUrl = "http://api.html2pdfrocket.com/pdf";
        String mUrl = webUrl;
        InputStreamReader request = new InputStreamReader(Request.Method.POST, webUrl,
                new Response.Listener<byte[]>() {
                    @Override
                    public void onResponse(byte[] response) {
                        // TODO handle the response
                        try {
                            if (response != null) {
                                Random r = new Random();
                                int i1 = r.nextInt(80 - 65) + 65;
                                fileName = "sample" + i1 + ".pdf";
                                root = new File(Environment.getExternalStorageDirectory(), "WebPageToImage");
                                if (!root.exists()) {
                                    root.mkdirs();
                                }
                                if (root.exists()) {


                                    gpxfile = new File(root, "sample" + i1 + ".jpg");
                                    OutputStream op = new FileOutputStream(gpxfile);
                                    gpxfile.setWritable(true);
                                    op.write(response);
                                    op.flush();
                                    op.close();


                                }
                                tvConversionContent.setText(response.toString());
                                Toast.makeText(getBaseContext(), "Content Write To the file name sample" + i1 + ".jpg in WebPageToImage Directory", Toast.LENGTH_LONG).show();
                                System.out.print("Response ----------------------" + response.toString());

                            }
                        } catch (Exception e) {
                            Log.d("KEY_ERROR", "UNABLE TO DOWNLOAD FILE");
                            e.printStackTrace();
                        }
                    }
                }
                , new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                error.printStackTrace();
            }
        }, params);
        RequestQueue mRequestQueue = Volley.newRequestQueue(getApplicationContext(), new HurlStack());
        mRequestQueue.add(request);

    }
    public void toConvertHtmlStringToPdf(){
        strApiKey = "af6f46c4-471c-4ce8-8b70-3c78e8ec796b";//Web api Parameter
        strValue = "<h1>An <strong>Example</strong>HTML String</h1>"; //Web api Parameter
        webUrl = "http://api.html2pdfrocket.com/pdf";//Web Api Url
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("apiKey", strApiKey);
        params.put("value", strValue);
        webUrl = "http://api.html2pdfrocket.com/pdf";
        String mUrl = webUrl;
        InputStreamReader request = new InputStreamReader(Request.Method.POST, webUrl,
                new Response.Listener<byte[]>() {
                    @Override
                    public void onResponse(byte[] response) {
                        // TODO handle the response
                        try {
                            if (response != null) {
                                Random r = new Random();
                                int i1 = r.nextInt(80 - 65) + 65;
                                fileName = "sample" + i1 + ".pdf";
                                root = new File(Environment.getExternalStorageDirectory(), "HtmlStringToPDF");
                                if (!root.exists()) {
                                    root.mkdirs();
                                }
                                if (root.exists()) {


                                    gpxfile = new File(root, "sample" + i1 + ".pdf");
                                    OutputStream op = new FileOutputStream(gpxfile);
                                    gpxfile.setWritable(true);
                                    op.write(response);
                                    op.flush();
                                    op.close();


                                }
                                tvConversionContent.setText(response.toString());
                                Toast.makeText(getBaseContext(), "Content Write To the file name sample" + i1 + ".pdf in WebPageToImage Directory", Toast.LENGTH_LONG).show();
                                System.out.print("Response ----------------------" + response.toString());

                            }
                        } catch (Exception e) {
                            Log.d("KEY_ERROR", "UNABLE TO DOWNLOAD FILE");
                            e.printStackTrace();
                        }
                    }
                }
                , new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                error.printStackTrace();
            }
        }, params);
        RequestQueue mRequestQueue = Volley.newRequestQueue(getApplicationContext(), new HurlStack());
        mRequestQueue.add(request);
    }
}

class InputStreamReader extends Request<byte[]> {
    private final Response.Listener<byte[]> mListener;
    private Map<String, String> mParams;
    public Map<String, String> responseHeaders;

    public InputStreamReader(int method, String mUrl, Response.Listener<byte[]> listener,
                             Response.ErrorListener errorListener, HashMap<String, String> params) {
        // TODO Auto-generated constructor stub

        super(method, mUrl, errorListener);
        //super(post,mUrl,errorListener);
        // this request would never use cache.
        setShouldCache(false);
        mListener = listener;
        mParams = params;
    }

    @Override
    protected Map<String, String> getParams()
            throws com.android.volley.AuthFailureError {
        return mParams;
    }

    ;


    @Override
    protected void deliverResponse(byte[] response) {
        mListener.onResponse(response);
    }

    @Override
    protected Response<byte[]> parseNetworkResponse(NetworkResponse response) {

        //Initialise local responseHeaders map with response headers received
        responseHeaders = response.headers;

        //Pass the response data here
        return Response.success(response.data, HttpHeaderParser.parseCacheHeaders(response));
    }
}